/*
 * Copyright 1998-2003 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2003 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * VIA, S3 GRAPHICS, AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#define I2C_ADR                          0
#define I2C_SUBADR                       1
#define I2C_DAT                          2
#define I2C_SCL                          0
#define I2C_SDA                          1
#define LOCLK                            0
#define HICLK                            1
/* Maximum transfer rate of I2C is 100 kbits/s. */
/* It's about 10 milisecond                     */
#define I2CTime                          1
#define I2CPort                          0x31
#define I2CAddrTV                        0x40

void    I2C_Enable(int);
int     I2C_wdata_pc(int, unsigned, unsigned);
void    I2C_start_pc(int);
void    I2C_stop_pc(int);
int     I2C_ack_pc(int);
int     I2C_regread_pc(int, unsigned);
void    I2C_regwrit_pc(int, unsigned, unsigned);
long    I2C_reverk(register unsigned data);
void    I2C_Delay1(unsigned long);
void    I2C_wdata(int pcIndexReg, int addr, int subAddr, int data);
int     I2C_rdata(int pcIndexReg, int addr, unsigned subAddr);
int     I2C_Write(int pcIndexReg, int addr, unsigned char *WriteBuffer, int nWrite);
